type 'a t
(** The type of abstract stacks. *)
val empty : 'a t
(** The empty stack. *)
val push : 'a -> 'a t -> 'a t
(** [push e s] pushes the element [e] on top of
the stack [s]. *)
val pop : 'a t -> ('a * 'a t)
(** [pop s] returns a pair, where the first component
is the top of the stack and the second [s] without
that element. *)
